/*
 *  old addressbook window
 */

async function abwindow_legacy(w) {
  if (!prefs) return; //not fully initialized
debug('Legacy addressbook loaded, try adding menu items');

  w.checkBookType=(sd)=>{
    let hide=sd?sd.isMailList:false;
    let p=sd.dirPrefId;
    if (!prefs.hasOwnProperty(p+'.down')) hide=true;
    w.document.querySelectorAll("[class=absDown]").forEach(e => {e.hidden = hide; });
    if (prefs['noupload']) hide=true;
    w.document.querySelectorAll("[class=absUp]").forEach(e => {e.hidden = hide; });
  }
  let tm=w.document.getElementById('taskPopup');
  let sep=w.document.getElementById('prefSep');
debug('Addressbook '+tm+' '+sep);

  // Task menu entries
  if (sep) {    //no sep on MacOS, the menu bar works quite differently
    let up=sep.previousSibling.cloneNode();
    up.label=strings['upload_title'];
    up.removeAttribute('accesskey');
    up.setAttribute('oncommand', "Services.obs.notifyObservers(null, 'abs_upload', '');");
    if (prefs['noupload']) up.hidden=true;
    let down=sep.previousSibling.cloneNode();
    down.label=strings['download_title'];
    down.removeAttribute('accesskey');
    down.setAttribute('oncommand', "Services.obs.notifyObservers(null, 'abs_download', '');");
    tm.insertBefore(down, sep);
    tm.insertBefore(up, sep);
  }

  // context menu entries
  let dtc=w.document.getElementById('dirTreeContext');
//onpopupshowing="updateDirTreeContext();"
  let ops=dtc.getAttribute('onpopupshowing');
debug('dirTreeContext onpopupshowing='+ops);
  dtc.setAttribute('onpopupshowing', ops+' checkBookType(getSelectedDirectory());');
/*
document.getElementById('dirTreeContext-abs-upload').disabled=iml;
document.getElementById('dirTreeContext-abs-download').disabled=iml;
*/
  let d=w.document.getElementById('dirTreeContext-delete');
  let sep2=d.previousSibling.cloneNode();
  sep2.classList.add('absDown');
  let ups=d.cloneNode();
  ups.id='dirTreeContext-abs-upload';
  ups.className='absUp';
  ups.label=strings['addressbookssync_upload'];
  ups.removeAttribute('accesskey');
  ups.removeAttribute('command');
  ups.setAttribute('oncommand', "Services.obs.notifyObservers(null, 'abs_upload', \
      JSON.stringify({ uri: getSelectedDirectoryURI() }) );");
  if (prefs['noupload']) ups.hidden=true;
  let downs=d.cloneNode();
  downs.id='dirTreeContext-abs-download';
  downs.className='absDown';
  downs.label=strings['addressbookssync_download'];
  downs.removeAttribute('accesskey');
  downs.removeAttribute('command');
  downs.setAttribute('oncommand', "Services.obs.notifyObservers(null, 'abs_download',\
      JSON.stringify({ uri: getSelectedDirectoryURI() }) );");
  dtc.insertBefore(ups, d);
  dtc.insertBefore(downs, d);
  dtc.insertBefore(sep2, d);

  // create toolbar buttons
  stylesheets(w);
  let toolbox=w.document.getElementById("ab-toolbox");
  let btn=button('de-ggbs-abs-UploadIcon', "upload_title", 'upload', w.document, toolbox);
  if (prefs['noupload']) btn.hidden=true;
  button('de-ggbs-abs-DownloadIcon', "download_title", 'download', w.document, toolbox);
  // show buttons in toolbar if already moved there
  let toolbar=w.document.getElementById("ab-bar2");
  let cs=Services.xulStore.getValue(w.document.location, "ab-bar2", "currentset");
debug('set currentSet to "'+cs+'"');
	if (cs) toolbar.currentSet = cs;  // this also sets the attribute, cs is empty on MacOS on first call
	//toolbar.setAttribute("currentset", cs); //just sets the attribute but does not show the buttons
  return;
}
function stylesheets(win) {
  if (!win.document.documentElement) {
debug('delay loading of stylesheet')
    win.setTimeout(stylesheets, 500, win);
    return;
  }
	let link=win.document.createElement("link");
	link.setAttribute("rel", "stylesheet");
  link.setAttribute("href", "chrome://addressbookssync/content/skin/abs_addressbook.css");
  win.document.documentElement.appendChild(link);
debug('stylesheet loaded into '+win.location);
}
function button(id, label, direction, doc, tbox) {
	let btn=doc.createXULElement("toolbarbutton");
	btn.setAttribute("id", id);
	btn.setAttribute("class", "toolbarbutton-1");
	let l=gContext.extension.localeData.localizeMessage(label);
	btn.setAttribute("label", l);
	btn.setAttribute("tooltiptext", l);
	btn.setAttribute("removable", "true");
	btn.setAttribute("oncommand", "Services.obs.notifyObservers(null, 'abs_"+direction+"', '');");
	tbox.palette.appendChild(btn);	//append to palette
debug('button installed');
  return btn;
}

/****************************************************************************/

/*
 *  new addressbook tab
 */

async function abwindow(w) {
  if (!prefs) return; //not fully initialized
debug('New addressbook loaded, try adding menu items window='+w+' '+w.docShell.outerWindowID);

  let tbb=w.document.getElementById('toolbarCreateContact');
  if (!tbb || !tbb.firstChild) {
debug('  addressbook window not fully loaded, wait...');
    w.setTimeout(abwindow, 100, w, 1);
    return;
  }
  let booksList = w.document.getElementById("books");
  booksList.absUpDownloadSelected=(direction)=>{
//console.log('booksList.'+direction+' '+booksList.selectedIndex);
    let row = booksList.rows[booksList.selectedIndex];
    if (row.classList.contains("bookRow")) {  //only books
      Services.obs.notifyObservers(null, 'abs_'+direction,
        JSON.stringify({ uid: row.dataset.uid}) );
    } //else console.log('no book selected, probably a list');
  }
  var selectedBook=null;
  booksList.addEventListener('select', (event)=>{
    for (let li of booksList.getElementsByTagName('li')) {
      if (li.getAttribute('aria-selected')=='true') {
        selectedBook=li;
        break;
      }
    }
  });
  let bcm=w.document.getElementById('bookContext');
  bcm.addEventListener('popupshowing', (event)=>{
    let hide=!selectedBook.classList.contains('bookRow');  //hide lists
    //if (selectedBook.classList.contains('carddav')) hide=true;
    let p=u2i[selectedBook.getAttribute('data-uid')];
    let dhide=hide;
    if (!prefs.hasOwnProperty(p+'.down') || !prefs[p+'.down']) dhide=true;
    w.document.getElementById('bookContextABSdownload').hidden=dhide;
    let uhide=hide;
    if (prefs['noupload'] || !prefs.hasOwnProperty(p+'.up') || !prefs[p+'.up']) uhide=true;
    w.document.getElementById('bookContextABSupload').hidden=uhide;
  });

  let tb=w.document.getElementById('toolbox');
  let item=w.document.getElementById('toolbarCreateContact');
//<xul:toolbarbutton id="toolbarCreateContact" class="toolbarbutton-1"
//   data-l10n-id="about-addressbook-toolbar-new-contact"
//   label="Neuer Kontakt" disabled="true">
//    <xul:image class="toolbarbutton-icon" label="Neuer Kontakt"/>
//    <xul:label class="toolbarbutton-text" crop="right" flex="1" value="Neuer Kontakt"/>
//</xul:toolbarbutton>
  let down=item.cloneNode(true);
  down.id='toolbarABSdownload';
  down.removeAttribute('data-l10n-id');
  down.label=strings['download_title'];
  down.firstChild.label=strings['download_title'];
  down.firstChild.nextSibling.value=strings['download_title'];
  down.addEventListener('command', event=>{Services.obs.notifyObservers(null, 'abs_download', '');});
  down.disabled=false;
  down.style.listStyleImage="url(\"chrome://addressbookssync/content/skin/download.svg\"";
  tb.firstChild.appendChild(down);
  let up=item.cloneNode(true);
  up.id='toolbarABSupload';
  up.removeAttribute('data-l10n-id');
  up.label=strings['upload_title'];
  up.firstChild.label=strings['upload_title'];
  up.firstChild.nextSibling.value=strings['upload_title'];
  up.addEventListener('command', event=>{Services.obs.notifyObservers(null, 'abs_upload', '');});
  up.disabled=false;
  up.style.listStyleImage="url(\"chrome://addressbookssync/content/skin/upload.svg\"";
  if (prefs['noupload']) up.hidden=true;
  tb.firstChild.appendChild(up);

  let bc=w.document.getElementById('bookContext');
  item=w.document.getElementById('bookContextProperties');
//<xul:menuitem id="bookContextProperties" data-l10n-id="about-addressbook-books-context-properties"
//  oncommand="booksList.showPropertiesOfSelected();" label="Eigenschaften">
//    <xul:label class="menu-text" crop="right" aria-hidden="true" value="Eigenschaften"/>
//    <xul:hbox class="menu-accel-container" aria-hidden="true"><xul:label class="menu-accel"/>
//    </xul:hbox>
//</xul:menuitem>
  down=item.cloneNode(true);
  down.id='bookContextABSdownload';
  down.removeAttribute('data-l10n-id');
  down.label=strings['addressbookssync_download'];
//  down.setAttribute('oncommand', "booksList.absUpDownloadSelected('download');");
  down.addEventListener('command', event=>{booksList.absUpDownloadSelected('download');});
  bc.appendChild(down);

  up=item.cloneNode(true);
  up.id='bookContextABSupload';
  up.removeAttribute('data-l10n-id');
  up.label=strings['addressbookssync_upload'];
//  up.setAttribute('oncommand', "booksList.absUpDownloadSelected('upload');");
  up.addEventListener('command', event=>{booksList.absUpDownloadSelected('upload');});
  bc.appendChild(up);
}
